//! Testing the abi generated by the [`CreateTypeSpec`] macro
#![allow(dead_code)]
use std::collections::BTreeSet;

use create_type_spec_derive::CreateTypeSpec;
use pbc_abi::create_type_spec::{NamedTypeLookup, NamedTypeSpecs};
use pbc_abi::CreateTypeSpec;
use pbc_contract_common::abi::abi_model::{AbiSerialize, NamedTypeSpec};
use pbc_contract_common::abi::generate::generate_abi;
use pbc_contract_common::sorted_vec_map::SortedVecMap;
use pbc_contract_common::zk::evm_event::{EventSubscriptionId, ExternalEventId};
use pbc_contract_common::zk::SecretVarId;
use read_write_state_derive::ReadWriteState;
use sdk_tests::state_types::{DepthFirstEnum, EnumItemStruct, NestedEnum, Pair};
use std::marker::PhantomData;

// Structs

#[allow(dead_code)]
#[derive(CreateTypeSpec)]
struct DeriveAbiForMe {
    a: String,
    b: u64,
    c: u8,
    d: Vec<Vec<Vec<Vec<u8>>>>,
}

#[allow(dead_code)]
#[derive(CreateTypeSpec)]
struct Nested {
    derived: DeriveAbiForMe,
}

#[derive(Ord, PartialOrd, Eq, PartialEq, Clone, CreateTypeSpec, ReadWriteState)]
struct Inner {
    x: u8,
}

/// CreateTypeSpec supports PhantomData in ABI.
#[derive(Ord, PartialOrd, Eq, PartialEq, Clone, CreateTypeSpec)]
struct Id<T> {
    raw: u32,
    type_t: PhantomData<T>,
}

#[derive(Clone, CreateTypeSpec)]
struct Outer {
    #[allow(dead_code)]
    inner: Inner,
}

#[derive(Clone, CreateTypeSpec)]
struct OuterMapKey {
    #[allow(dead_code)]
    inner: SortedVecMap<Inner, String>,
}

/// CreateTypeSpec supports PhantomData in ABI.
#[derive(Clone, CreateTypeSpec)]
struct IdMapState {
    #[allow(dead_code)]
    map: SortedVecMap<Id<String>, String>,
}

#[derive(Clone, CreateTypeSpec)]
struct OuterMapValue {
    #[allow(dead_code)]
    inner: SortedVecMap<String, Inner>,
}

#[derive(Clone, CreateTypeSpec)]
struct OuterVec {
    #[allow(dead_code)]
    inner: Vec<Inner>,
}

#[derive(Clone, CreateTypeSpec)]
struct OuterBTreeSet {
    #[allow(dead_code)]
    inner: BTreeSet<Inner>,
}

#[derive(Clone, CreateTypeSpec)]
struct OuterComposite {
    #[allow(dead_code)]
    inner: Vec<BTreeSet<Vec<SortedVecMap<Inner, String>>>>,
}

#[derive(Clone, CreateTypeSpec)]
struct WithArray {
    #[allow(dead_code)]
    inner: [u8; 50],
}

#[derive(Clone, PartialOrd, Ord, PartialEq, Eq, CreateTypeSpec)]
enum MyRoleEnum<RankT: PartialOrd + PartialEq + Eq + Ord + Clone> {
    #[discriminant(1)]
    Admin {},
    #[discriminant(2)]
    Moderator {},
    #[discriminant(3)]
    User { rank: RankT },
}

#[derive(Clone, PartialOrd, Ord, PartialEq, Eq, CreateTypeSpec)]
struct MiniAccess {} // No access

#[derive(Clone, CreateTypeSpec)]
struct AccessControl<RoleT: Ord + Clone> {
    pub role_mappings: SortedVecMap<RoleT, RoleT>,
}

#[derive(Clone, CreateTypeSpec)]
struct StateWithAccessControl {
    pub access_control: AccessControl<MyRoleEnum<u32>>,
}

#[derive(CreateTypeSpec)]
struct LinkedTree<T: CreateTypeSpec> {
    value: T,
    children: Vec<LinkedTree<T>>,
}

#[derive(CreateTypeSpec)]
enum MyOptionEnum<T: CreateTypeSpec> {
    #[discriminant(0)]
    None {},
    #[discriminant(1)]
    Some { value: T },
    #[discriminant(2)]
    More { values: Vec<MyOptionEnum<T>> },
}

// Derive tests

#[test]
fn generate_abi_test() {
    unsafe {
        let vec = Vec::with_capacity(0);
        generate_abi::<DeriveAbiForMe>([0, 0, 0], [0, 0, 0], 0, vec.as_ptr());
    }
}

#[test]
fn implemented_create_type_spec_trait() {
    assert_eq!(DeriveAbiForMe::__ty_name(), "DeriveAbiForMe".to_string());
}

#[test]
fn nested_structs() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    let type_spec = Nested::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);
    assert_abi(&type_spec, vec![0x00, 0x00]);

    let expected_nested = vec![
        1, // It's a struct
        0, 0, 0, 6, // Length of name
        b'N', b'e', b's', b't', b'e', b'd', // Name
        0, 0, 0, 1, // 1 field
        0, 0, 0, 7, // Length of field name
        b'd', b'e', b'r', b'i', b'v', b'e', b'd', // Field name
        0, 1, // pointer to DeriveAbiForMe as inserted in named_type_indexes
    ];

    assert_eq!(named_type_specs.len(), 2);
    assert_eq!(named_type_indexes.get(&Nested::__ty_identifier()), Some(&0));
    let generated_type_spec = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec, expected_nested);

    let expected_derive_abi_for_me = vec![
        1, // It's a struct
        0, 0, 0, 14, // Length of name
        b'D', b'e', b'r', b'i', b'v', b'e', b'A', b'b', b'i', b'F', b'o', b'r', b'M',
        b'e', // Name
        0, 0, 0, 4, // 4 fields
        0, 0, 0, 1,    // Length of field name
        b'a', // Field name
        11,   // String
        0, 0, 0, 1,    // Length of field name
        b'b', // Field name
        4,    //u64
        0, 0, 0, 1,    // Length of field name
        b'c', // Field name
        1,    //u8
        0, 0, 0, 1,    // Length of field name
        b'd', // Field name
        14, 14, 14, 14, 1, // Vec<Vec<Vec<Vec<u8>>>>
    ];
    assert_eq!(
        named_type_indexes.get(&DeriveAbiForMe::__ty_identifier()),
        Some(&1)
    );
    let generated_type_spec = named_type_specs.get(&1).unwrap();
    assert_abi(generated_type_spec, expected_derive_abi_for_me);
}

#[test]
fn serialize_inner() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    let type_spec = Inner::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);
    assert_abi(&type_spec, vec![0x00, 0x00]);

    let expected: Vec<u8> = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 0x05, // Length of name
        73, 110, 110, 101, 114, // "Inner"
        0x00, 0x00, 0x00, 0x01, // 1 field
        0x00, 0x00, 0x00, 0x01, // 1 character name
        120,  // x
        0x01, // u8
    ];
    let generated_type_spec = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec, expected);
}

#[test]
fn serialize_outer_with_inner_struct() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    Outer::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_outer = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 0x05, // Length of name
        79, 117, 116, 101, 114, // "Outer"
        0, 0, 0, 1, // 1 field
        0, 0, 0, 5, // field name length, len 5
        0x69, 0x6e, 0x6e, 0x65, 0x72, // "inner"
        0x00, 0x01, // Struct at index = 1
    ];

    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec_outer, expected_outer);

    let expected_inner: Vec<u8> = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 0x05, // Length of name
        73, 110, 110, 101, 114, // "Inner"
        0x00, 0x00, 0x00, 0x01, // 1 field
        0x00, 0x00, 0x00, 0x01, // 1 character name
        120,  // x
        0x01, // u8
    ];
    let generated_type_spec_inner = named_type_specs.get(&1).unwrap();
    assert_abi(generated_type_spec_inner, expected_inner);
}

#[test]
fn serialize_inner_as_key_in_map() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    OuterMapKey::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_outer = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 11, // Length of name = 11
        79, 117, 116, 101, 114, 77, 97, 112, 75, 101, 121, // The string "OuterMapKey"
        0, 0, 0, 1, // 1 field
        0, 0, 0, 5, // field name length, length = 5
        0x69, 0x6e, 0x6e, 0x65, 0x72, // "inner"
        0x0f, 0, 1, 0x0b, // SortedVecMap<Struct at index = 1, String>
    ];
    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec_outer, expected_outer);
}

#[test]
fn serialize_inner_as_value_in_map() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    OuterMapValue::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_outer = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 13, // Length of name = 13
        0x4f, 0x75, 0x74, 0x65, 0x72, 0x4d, 0x61, 0x70, 0x56, 0x61, 0x6c, 0x75,
        0x65, // The string "OuterMapValue"
        0, 0, 0, 1, // 1 field
        0, 0, 0, 5, // field name length, length = 5
        0x69, 0x6e, 0x6e, 0x65, 0x72, // "inner"
        0x0f, 0x0b, 0, 1, // SortedVecMap<String, Struct at index = 1>
    ];
    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec_outer, expected_outer);
}

/// [`CreateTypeSpec`] can contain PhantomData.
#[test]
fn serialize_id_with_phantom_data() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    Id::<String>::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_abi_bytes = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 8, // Length of name
        b'I', b'd', b'S', b't', b'r', b'i', b'n', b'g', 0, 0, 0, 2, // 1 field
        0, 0, 0, 3, // field 1 name length,
        b'r', b'a', b'w', 0x03, // u32
        0, 0, 0, 6, // field 2 name length,
        b't', b'y', b'p', b'e', b'_', b't', 26, 1, 0, // Empty byte array.
    ];
    let generated_type_spec = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec, expected_abi_bytes);
}

/// [`CreateTypeSpec`] can contain PhantomData.
#[test]
fn serialize_id_map_state_with_phantom_data() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    IdMapState::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_abi_bytes = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 10, // Length of name = 13
        b'I', b'd', b'M', b'a', b'p', b'S', b't', b'a', b't', b'e', 0, 0, 0, 1, // 1 field
        0, 0, 0, 3, // field name length,
        b'm', b'a', b'p', 0x0f, 0, 1, 11, // SortedVecMap<Id, String>
    ];
    let generated_type_spec = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec, expected_abi_bytes);
}

#[test]
fn serialize_inner_in_btreeset() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    OuterBTreeSet::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_outer = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 13, // Length of name = 13
        79, 117, 116, 101, 114, 66, 84, 114, 101, 101, 83, 101,
        116, // The string "OuterBTreeSet"
        0, 0, 0, 1, // 1 field
        0, 0, 0, 5, // field name length, length = 5
        0x69, 0x6e, 0x6e, 0x65, 0x72, // "inner"
        0x10, 0, 1, // BTreeSet<Struct at index = 1>
    ];
    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec_outer, expected_outer);
}

#[test]
fn serialize_inner_in_vec() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    OuterVec::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_outer = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 8, // Length of name = 8
        79, 117, 116, 101, 114, 86, 101, 99, // The string "OuterVec"
        0, 0, 0, 1, // 1 field
        0, 0, 0, 5, // field name length, len 5
        0x69, 0x6e, 0x6e, 0x65, 0x72, // "inner"
        0x0e, 0, 1, // Vec<Struct at index = 1>
    ];
    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec_outer, expected_outer);
}

#[test]
fn serialize_inner_in_composite() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    OuterComposite::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected_outer = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 14, // Length of name = 8
        79, 117, 116, 101, 114, 67, 111, 109, 112, 111, 115, 105, 116,
        101, // The string "OuterComposite"
        0, 0, 0, 1, // 1 field
        0, 0, 0, 5, // field name length, len 5
        0x69, 0x6e, 0x6e, 0x65, 0x72, // "inner"
        0x0e, 0x10, 0x0e, 0x0f, 0x00, 0x01,
        0x0b, // Vec<BTreeSet<Vec<SortedVecMap<Inner, with index = 1, String>>>>
    ];
    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec_outer, expected_outer);
}

#[test]
fn serialize_struct_with_array() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    WithArray::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, 9, // Length of name
        b'W', b'i', b't', b'h', b'A', b'r', b'r', b'a', b'y', // Name
        0, 0, 0, 1, // 1 field
        0, 0, 0, 5, // field name length
        b'i', b'n', b'n', b'e', b'r', // Field name
        26, 1, 50, // Byte array with length 50.
    ];
    let generated_type_spec = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec, expected);
}

/// Test that ABI can be generated for the given Id type.
///
/// - name: Name of the type.
/// - discriminant_inner: Discriminant for the inner type. Generally either `u32` or `i32`.
fn assert_abi_for_id<T: CreateTypeSpec>(name: &str, discriminant_inner: u8) {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    T::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let result: &NamedTypeSpec = named_type_specs.get(&0).unwrap();

    let mut expected: Vec<u8> = vec![
        0x01, // It's a struct
        0x00, 0x00, 0x00, // Length of name
    ];
    expected.push(name.len() as u8); // Length of name
    expected.extend(name.bytes()); // name
    expected.extend([0, 0, 0, 1]); // 1 fields
    expected.extend([0, 0, 0, 6]); // field 1 name length
    expected.extend("raw_id".bytes()); // field 1 name
    expected.push(discriminant_inner); // Field 1 type: inner

    assert_abi(result, expected);
}

/// ABI should work for ids:
///
/// - [`SecretVarId`]
/// - [`EventSubscriptionId`]
#[test]
fn abi_for_ids() {
    const DISCRIMINANT_U32: u8 = 0x03;
    const DISCRIMINANT_I32: u8 = 0x08;
    assert_abi_for_id::<SecretVarId>("SecretVarId", DISCRIMINANT_U32);
    assert_abi_for_id::<EventSubscriptionId>("EventSubscriptionId", DISCRIMINANT_I32);
    assert_abi_for_id::<ExternalEventId>("ExternalEventId", DISCRIMINANT_I32);
}

#[test]
fn serialize_enum() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    EnumItemStruct::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let expected: Vec<u8> = vec![
        0x02, // It's an enum
        0x00, 0x00, 0x00, 0x0E, // Length of name
        b'E', b'n', b'u', b'm', b'I', b't', b'e', b'm', b'S', b't', b'r', b'u', b'c',
        b't', // Name
        0x00, 0x00, 0x00, 0x03, // 3 variants
        0x00, // discriminant for A
        0x00, 0x01, // pointer to A
        0x03, // discriminant for B
        0x00, 0x02, // pointer to B
        0x7D, // discriminant for C
        0x00, 0x03, // pointer to C
    ];
    let generated_type_spec = named_type_specs.get(&0).unwrap();
    assert_abi(generated_type_spec, expected);
}

#[test]
fn serialize_enum_variants() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    EnumItemStruct::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let enum_variant_a = named_type_specs.get(&1).unwrap();
    let expected: Vec<u8> = vec![
        0x01, // It's a struct
        0, 0, 0, 1,    // Length of name
        b'A', // Name
        0, 0, 0, 1, // 1 field
        0, 0, 0, 1,    // field name length
        b'a', // Field name
        0x01, // u8
    ];
    assert_abi(enum_variant_a, expected);

    let enum_variant_b = named_type_specs.get(&2).unwrap();
    let expected: Vec<u8> = vec![
        0x01, // It's a struct
        0, 0, 0, 1,    // Length of name
        b'B', // Name
        0, 0, 0, 2, // 2 fields
        0, 0, 0, 1,    // field name length
        b'a', // Field name
        0x01, // u8
        0, 0, 0, 1,    // field name length
        b'b', // Field name
        0x01, // u8
    ];
    assert_abi(enum_variant_b, expected);

    let enum_variant_c = named_type_specs.get(&3).unwrap();
    let expected: Vec<u8> = vec![
        0x01, // It's a struct
        0, 0, 0, 1,    // Length of name
        b'C', // Name
        0, 0, 0, 1, // 1 field
        0, 0, 0, 1,    // field name length
        b'a', // Field name
        0x00, 0x04, // Pointer to Inner
    ];
    assert_abi(enum_variant_c, expected);
}

#[test]
fn serialize_nested_enum() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    NestedEnum::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let nested_enum = named_type_specs.get(&0).unwrap();
    let expected: Vec<u8> = vec![
        0x02, // It's an enum
        0, 0, 0, 0x0A, // Length of name
        b'N', b'e', b's', b't', b'e', b'd', b'E', b'n', b'u', b'm', // Name
        0, 0, 0, 1,    // 1 variant
        0x09, // discriminant for One
        0x00, 0x01, // pointer to One
    ];
    assert_abi(nested_enum, expected);

    let one_struct = named_type_specs.get(&1).unwrap();
    let expected: Vec<u8> = vec![
        0x01, // It's a struct
        0, 0, 0, 3, // Length of name
        b'O', b'n', b'e', // Name
        0, 0, 0, 1, // 1 field
        0, 0, 0, 1,    // field name length
        b'a', // Field name
        0x00, 0x02, // Pointer to EnumItemStruct
    ];
    assert_abi(one_struct, expected);

    let nested_enum_item_struct = named_type_specs.get(&2).unwrap();
    let expected: Vec<u8> = vec![
        0x02, // It's an enum
        0x00, 0x00, 0x00, 0x0E, // Length of name
        b'E', b'n', b'u', b'm', b'I', b't', b'e', b'm', b'S', b't', b'r', b'u', b'c',
        b't', // Name
        0x00, 0x00, 0x00, 0x03, // 3 variants
        0x00, // discriminant for A
        0x00, 0x03, // pointer to A
        0x03, // discriminant for B
        0x00, 0x04, // pointer to B
        0x7D, // discriminant for C
        0x00, 0x05, // pointer to C
    ];
    assert_abi(nested_enum_item_struct, expected);
}

#[test]
fn type_names_for_generic() {
    assert_eq!(MyRoleEnum::<u32>::__ty_name(), "MyRoleEnumU32");
    assert_eq!(MyRoleEnum::<Vec<u32>>::__ty_name(), "MyRoleEnumVecU32");
    assert_eq!(
        AccessControl::<MiniAccess>::__ty_name(),
        "AccessControlMiniAccess"
    );
    assert_eq!(
        StateWithAccessControl::__ty_name(),
        "StateWithAccessControl"
    );
    assert!(MyRoleEnum::<u32>::__ty_identifier().ends_with("U32"));
    assert!(!AccessControl::<MiniAccess>::__ty_identifier().is_empty());
}

#[test]
fn create_type_spec_for_generics() {
    // Test ABI
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    StateWithAccessControl::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);

    let state_abi = named_type_specs.get(&0).unwrap();
    let expected = vec![
        1, // Struct
        0, 0, 0, 22, // Name length
        83, 116, 97, 116, 101, 87, 105, 116, 104, 65, 99, 99, 101, 115, 115, 67, 111, 110, 116,
        114, 111, 108, // StateWithAccessControl
        0, 0, 0, 1, // One field
        0, 0, 0, 14, // Field name
        97, 99, 99, 101, 115, 115, 95, 99, 111, 110, 116, 114, 111, 108, // access_control
        0, 1, // pointer to type inserted in lut
    ];
    assert_abi(state_abi, expected);

    let access_control_abi = named_type_specs.get(&1).unwrap();
    let expected = vec![
        1, // Struct
        0, 0, 0, 26, // Name length
        65, 99, 99, 101, 115, 115, 67, 111, 110, 116, 114, 111, 108, 77, 121, 82, 111, 108, 101,
        69, 110, 117, 109, 85, 51, 50, // AccessControlMyRoleEnumU32
        0, 0, 0, 1, // One field
        0, 0, 0, 13, // Field name
        114, 111, 108, 101, 95, 109, 97, 112, 112, 105, 110, 103, 115, // role_mappings
        15, 0, 2, 0, 2, // SortedVecMap<MyRoleEnum @ index 2, MyRoleEnum @ index 2>
    ];
    assert_abi(access_control_abi, expected);

    let my_role_enum_abi = named_type_specs.get(&2).unwrap();
    let expected = vec![
        2, // Enum
        0, 0, 0, 13, // Name length
        77, 121, 82, 111, 108, 101, 69, 110, 117, 109, 85, 51, 50, // MyRoleEnumU32
        0, 0, 0, 3, // 3 Variants
        1, // Discriminant for Admin
        0, 3, // Pointer to admin
        2, // Discriminant for Moderator
        0, 4, // Pointer to Moderator
        3, // Discriminant for User
        0, 5, // Pointer to User
    ];
    assert_abi(my_role_enum_abi, expected);
}

#[test]
fn create_type_spec_for_recursive_struct() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    let type_ref = LinkedTree::<LinkedTree<Vec<u8>>>::__ty_generate_spec(
        &mut named_type_indexes,
        &mut named_type_specs,
    );
    assert_abi(&type_ref, vec![0, 0]);

    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    let expected_outer = vec![
        1, // Struct
        0, 0, 0, 25, // Name length
        76, 105, 110, 107, 101, 100, 84, 114, 101, 101, 76, 105, 110, 107, 101, 100, 84, 114, 101,
        101, 86, 101, 99, 85, 56, // LinkedTreeLinkedTreeVecU8
        0, 0, 0, 2, // 2 fields
        0, 0, 0, 5, // field name length
        118, 97, 108, 117, 101, // "value"
        0, 1, // pointer to LinkedTreeVecU8
        0, 0, 0, 8, // field name length
        99, 104, 105, 108, 100, 114, 101, 110, // "children"
        14, 0, 0, // Vec<pointer to LinkedTreeLinkedTreeVecU8>
    ];
    assert_abi(generated_type_spec_outer, expected_outer);

    let generated_type_spec_inner = named_type_specs.get(&1).unwrap();
    let expected_inner = vec![
        1, // Struct
        0, 0, 0, 15, // Name length
        76, 105, 110, 107, 101, 100, 84, 114, 101, 101, 86, 101, 99, 85,
        56, // LinkedTreeVecU8
        0, 0, 0, 2, // 2 fields
        0, 0, 0, 5, // field name length
        118, 97, 108, 117, 101, // "value"
        14, 1, // Vec<u8>
        0, 0, 0, 8, // field name length
        99, 104, 105, 108, 100, 114, 101, 110, // "children"
        14, 0, 1, // Vec<pointer to LinkedTreeVecU8>
    ];
    assert_abi(generated_type_spec_inner, expected_inner);
}

#[test]
fn create_type_spec_for_recursive_enum() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    let type_ref = MyOptionEnum::<LinkedTree<u8>>::__ty_generate_spec(
        &mut named_type_indexes,
        &mut named_type_specs,
    );
    assert_abi(&type_ref, vec![0, 0]);
}

/// [`CreateTypeSpec`] can generate ABI for types with multiple generic parameters.
#[test]
fn create_type_spec_for_double_generic_pair() {
    type T = Pair<u32, u32>;

    assert_eq!(T::__ty_name(), "PairU32U32");

    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    let type_ref = T::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);
    assert_abi(&type_ref, vec![0, 0]);

    let generated_type_spec_outer = named_type_specs.get(&0).unwrap();
    let expected_outer = vec![
        1, // Struct
        0, 0, 0, 10, // Name length
        80, 97, 105, 114, 85, 51, 50, 85, 51, 50, // Name: PairU32U32
        0, 0, 0, 2, // 2 fields
        0, 0, 0, 2, // field name length
        118, 49, // "v1"
        3,  // u32
        0, 0, 0, 2, // field name length
        118, 50, // "v2"
        3,  // u32
    ];
    assert_abi(generated_type_spec_outer, expected_outer);
}

#[test]
fn enum_type_spec_generated_depth_first() {
    let mut named_type_indexes = NamedTypeLookup::new();
    let mut named_type_specs = NamedTypeSpecs::new();
    let type_ref =
        DepthFirstEnum::__ty_generate_spec(&mut named_type_indexes, &mut named_type_specs);
    assert_abi(&type_ref, vec![0, 0]);

    let generated_type_spec_enum = named_type_specs.get(&0).unwrap();
    let expected_enum = vec![
        2, // Struct
        0, 0, 0, 14, // Name length
        68, 101, 112, 116, 104, 70, 105, 114, 115, 116, 69, 110, 117, 109, 0, 0, 0,
        3, // numbers of variants
        0, // discriminant,
        0, 1, // pointer to "A",
        3, // Discriminant
        0, 3,   // pointer to "B"
        125, // discriminant,
        0, 6, // pointer to C
    ];
    assert_abi(generated_type_spec_enum, expected_enum);
}

fn assert_abi<T: AbiSerialize>(obj: &T, expected: Vec<u8>) {
    let mut serialization = Vec::new();
    obj.serialize_abi(&mut serialization).unwrap();
    assert_eq!(serialization, expected);
}
